/*--------------------------------------------------------------------------------------*/
/*	LZW_GIFfR[_[{ t@C	Ver 1.00									*/
/*	for VisualStudio6.0 only															*/
/*	ۂ̓WJsADIBƂĕԋp܂B										*/
/*	Copyright (C) 2000 DJUchi [H.Uchida]												*/
/*--------------------------------------------------------------------------------------*/
#include "GIFDecode.h"


/*--------------------------------------------------------------------------------------*/
/*	GifDecode()																			*/
/*	GIF摜iŏ̈ꖇ̂݁jWJB												*/
/*	͂GIFf[^Ao͂DIBB														*/
/*	ł͎ɃfR[h̑Os܂B											*/
/*--------------------------------------------------------------------------------------*/
void GifDecode(BYTE *rgb, BYTE *gif, DWORD width, DWORD height,
			   DWORD align, DWORD inter ,WORD color, DWORD size)
{
	//GIFf[^͗p\̏
	GIFDECODESTATUS gs;
	gs.code_size	= gif[0];				//R[hTCY擾
	gs.bit_size		= gs.code_size + 1;		//CBLiR[hTCY+1j
	gs.clear_code	= 1 << gs.code_size;	//NAR[hݒi2^R[hTCYj
	gs.end_code		= gs.clear_code + 1;	//GhR[hݒi2^R[hTCY+1j
	gs.entry		= 0;					//fR[hʒui0j
	gs.bit_pt		= 8;					//rbg|C^(8bit=1byte)
	gs.next_block	= 1;					//ubNʒui擪ubNj
	gs.data_size	= size;					//GIFf[^TCY擾

	//DIBf[^ݗp\̏
	RGBDECODESTATUS rs;
	rs.gs			= &gs;					//GIFDECODESTATUS\̎QƗp|C^擾
	rs.rgb_pt		= 0;					//WJf[^݈ʒu
	rs.rgb_offset	= (height - 1) * align;	//݈ʒuItZbg
	rs.rgb_width	= width;				//DIBpixel擾
	rs.rgb_height	= height;				//DIBcpixel擾
	rs.rgb_align	= align;				//DIBACgl擾
	rs.rgb_color	= color;				//DIBJ[rbgl擾
	rs.rgb_line		= 0;					//WJf[^݃C
	rs.inter_offset	= 8;					//C^[XItZbg
	rs.inter_flag	= inter;				//C^[XtO擾

	//GhR[h܂łЂ烋[v
	while (lzw_string(rgb, gif, &rs, gs.entry++) != gs.end_code);

	return;
}


/*--------------------------------------------------------------------------------------*/
/*	GetCode()																			*/
/*	σrbg͊֐B																*/
/*	w肳ꂽʒuixԖځj̕R[hoB									*/
/*	of[^͂̂܂܃fR[hɓn܂B								*/
/*--------------------------------------------------------------------------------------*/
WORD GetCode(BYTE *gif, GIFDECODESTATUS *gs, int x)
{
	//GIF̕R[h͉σrbgŌԖ߂Ă邽߁A
	//Cӂ̈ʒu̕R[hꔭŎoƂ͕s\łB
	//ׁ̈A擪珇ɖړI̕R[hT[`Ă܂B

	DWORD code = 0;
	DWORD bit_pt = gs->bit_pt;
	DWORD pt;
	DWORD next_block = gs->next_block;
	DWORD bit_size = gs->code_size + 1;
	int bit_limit = (1 << bit_size) - gs->end_code - 2;

	//ړÏʒuɒB܂œǂݔ΂B
	int j = 0;
	while (j < x) {
		pt = bit_pt >> 3;
		while ((bit_pt + bit_size - 1) >> 3 >= pt) {
			if (pt == next_block) {
				next_block += gif[pt++] + 1;
				bit_pt += 8;
			}
			pt++;
		}
		bit_pt += bit_size;
		if ((j++ > bit_limit) && (bit_size < 12)) {
			bit_size++;
			bit_limit = (1 << bit_size) - gs->end_code - 2;
		}
	}

	//ړÏʒuɒBB
	pt = bit_pt >> 3;
	//TCYI[o[t[̏ꍇAIɃGhR[hԂijt@C΍j
	if (pt + 2 > gs->data_size) return (WORD)gs->end_code;
	//ړÏʒuɒB̂ŁȀꏊ̕R[h擾B
	int i = 0;
	while ((bit_pt + bit_size - 1) >> 3 >= pt) {
		if (pt == next_block) {
			next_block += gif[pt++] + 1;
			bit_pt += 8;
		}
		code += gif[pt++] << i;
		i += 8;
	}
	//ꂽR[h̗]ȃrbg؂Ƃ΂Bi}XLOj
	code = (code >> (bit_pt & 0x07)) & ((1 << bit_size) - 1);

	//oR[hNAR[hꍇB
	if (code == gs->clear_code) {
		gs->bit_pt = bit_pt + bit_size;
		gs->next_block = next_block;
		gs->entry = 0;
	}

	return (WORD)code;
}


/*--------------------------------------------------------------------------------------*/
/*	lzw_string()																		*/
/*	LZW_WJ֐iRAj															*/
/*	LZW_̊jB																	*/
/*	w肳ꂽR[hɑ΂WJf[^Ԃ܂B								*/
/*--------------------------------------------------------------------------------------*/
WORD lzw_string(BYTE *rgb, BYTE *gif, RGBDECODESTATUS *rs, int x)
{
	//z񂩂畄R[ho܂B
	WORD code = GetCode(gif, rs->gs, x);

	//R[hhFh菬ꍇ
	if (code < rs->gs->clear_code) {
		//R[ĥ܂DIBɏށB
		rgb_write(rgb, rs, code);

	//R[hNAR[hGhR[hłꍇ
	} else if (code <= rs->gs->end_code) {
		return code;

	//R[hm̂̂łꍇ
	} else if (code > rs->gs->end_code + x) {
		lzw_string(rgb, gif, rs, --x);
		lzw_char(rgb, gif, rs, --x);

	//R[hhF+1h傫ꍇ
	} else {
		lzw_string(rgb, gif, rs, code - rs->gs->end_code - 1);
		lzw_char(rgb, gif, rs, code - rs->gs->end_code);
	}

	return 0;
}


/*--------------------------------------------------------------------------------------*/
/*	lzw_char()																			*/
/*	LZW_WJ֐iTuj															*/
/*	LZW_̊jB																	*/
/*	w肳ꂽR[hɑ΂WJf[^̐擪PԂ܂B					*/
/*--------------------------------------------------------------------------------------*/
void lzw_char(BYTE *rgb, BYTE *gif, RGBDECODESTATUS *rs, int x)
{
	//z񂩂畄R[ho܂B
	WORD code = GetCode(gif, rs->gs, x);

	//R[hhFh菬ꍇ
	if (code < rs->gs->clear_code) {
		rgb_write(rgb, rs, code);

	//R[hm̂̂łꍇ
	} else if (code > rs->gs->end_code + x) {
		lzw_char(rgb, gif, rs, --x);

	//R[hhF+1h傫ꍇ
	} else {
		lzw_char(rgb, gif, rs, code - rs->gs->end_code - 1);
	}
}


/*--------------------------------------------------------------------------------------*/
/*	rgb_write()																			*/
/*	DIB摜f[^݊֐B															*/
/*	WJꂽ摜f[^DIBƂď݂܂B										*/
/*--------------------------------------------------------------------------------------*/
void rgb_write(BYTE *rgb, RGBDECODESTATUS *rs, WORD code)
{
	//DIBɉ摜f[^݂܂B
	//mN16F̏ꍇ̓rbgPʂł݂̏ɂȂׁA}XLOs܂B
	DWORD i, j;
	if (rs->rgb_color == 1) {			//mN摜̏ꍇ
		i = rs->rgb_offset + (rs->rgb_pt >> 3);
		j = 7 - (rs->rgb_pt & 0x07);
		rgb[i] = (rgb[i] & ~(1 << j)) | (code << j);
	} else if (rs->rgb_color == 4) {	//16F摜̏ꍇ
		i = rs->rgb_offset + (rs->rgb_pt >> 1);
		j = (rs->rgb_pt & 0x01) << 2;
		rgb[i] = (rgb[i] & (0x0F << j)) | (code << (4 - j));
	} else {							//256F̏ꍇ
		rgb[rs->rgb_offset + rs->rgb_pt] = (BYTE)code;
	}

	//݈ʒuCNg
	rs->rgb_pt++;
	//݈ʒuC̏I[ɒBꍇ
	if (rs->rgb_pt == rs->rgb_width) {
		if (rs->inter_flag) {	//C^[XGIF̏ꍇ
			//C^[XCʉ[ɒBꍇ
			if (rs->rgb_line + rs->inter_offset >= rs->rgb_height){
				if ((rs->rgb_line & 0x07) == 0) {
					rs->rgb_offset = (rs->rgb_height - 5) * rs->rgb_align;
					rs->rgb_line = 4;
				} else if (rs->inter_offset == 8) {
					rs->rgb_offset = (rs->rgb_height - 3) * rs->rgb_align;
					rs->rgb_line = 2;
					rs->inter_offset = 4;
				} else if (rs->inter_offset == 4) {
					rs->rgb_offset = (rs->rgb_height - 2) * rs->rgb_align;
					rs->rgb_line = 1;
					rs->inter_offset = 2;
				}
			} else {
				rs->rgb_offset -= rs->rgb_align * rs->inter_offset;
				rs->rgb_line += rs->inter_offset;
			}
		} else {				//jAGIF̏ꍇ
			rs->rgb_offset -= rs->rgb_align;
		}
		rs->rgb_pt = 0;
	}
}
